Loading...
Searching...
No Matches
pcl::PlaneCoefficientComparator< PointT, PointNT > Class Template Reference

PlaneCoefficientComparator is a Comparator that operates on plane coefficients, for use in planar segmentation. More...

`#include <pcl/segmentation/plane_coefficient_comparator.h>`

Inheritance diagram for pcl::PlaneCoefficientComparator< PointT, PointNT >:

## Public Types

using | PointCloud = typename Comparator< PointT >::PointCloud
using | PointCloudConstPtr = typename Comparator< PointT >::PointCloudConstPtr
using | PointCloudN = pcl::PointCloud< PointNT >
using | PointCloudNPtr = typename PointCloudN::Ptr
using | PointCloudNConstPtr = typename PointCloudN::ConstPtr
using | Ptr = shared_ptr< PlaneCoefficientComparator< PointT, PointNT > >
using | ConstPtr = shared_ptr< const PlaneCoefficientComparator< PointT, PointNT > >
Public Types inherited from pcl::Comparator< PointT >
using | PointCloud = pcl::PointCloud< PointT >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | Ptr = shared_ptr< Comparator< PointT > >
using | ConstPtr = shared_ptr< const Comparator< PointT > >

## Public Member Functions

| PlaneCoefficientComparator ()
| Empty constructor for PlaneCoefficientComparator.
| PlaneCoefficientComparator (shared_ptr< std::vector< float > > &plane_coeff_d)
| Constructor for PlaneCoefficientComparator.
| ~PlaneCoefficientComparator () override=default
| Destructor for PlaneCoefficientComparator.
void | setInputCloud (const PointCloudConstPtr &cloud) override
| Set the input cloud for the comparator.
void | setInputNormals (const PointCloudNConstPtr &normals)
| Provide a pointer to the input normals.
PointCloudNConstPtr | getInputNormals () const
| Get the input normals.
void | setPlaneCoeffD (shared_ptr< std::vector< float > > &plane_coeff_d)
| Provide a pointer to a vector of the d-coefficient of the planes' hessian normal form.
void | setPlaneCoeffD (std::vector< float > &plane_coeff_d)
| Provide a pointer to a vector of the d-coefficient of the planes' hessian normal form.
const std::vector< float > & | getPlaneCoeffD () const
| Get a pointer to the vector of the d-coefficient of the planes' hessian normal form.
virtual void | setAngularThreshold (float angular_threshold)
| Set the tolerance in radians for difference in normal direction between neighboring points, to be considered part of the same plane.
float | getAngularThreshold () const
| Get the angular threshold in radians for difference in normal direction between neighboring points, to be considered part of the same plane.
void | setDistanceThreshold (float distance_threshold, bool depth_dependent=false)
| Set the tolerance in meters for difference in perpendicular distance (d component of plane equation) to the plane between neighboring points, to be considered part of the same plane.
float | getDistanceThreshold () const
| Get the distance threshold in meters (d component of plane equation) between neighboring points, to be considered part of the same plane.
bool | compare (int idx1, int idx2) const override
| Compare points at two indices by their plane equations.
Public Member Functions inherited from pcl::Comparator< PointT >
| Comparator ()
| Empty constructor for comparator.
virtual | ~Comparator ()=default
| Empty destructor for comparator.
virtual PointCloudConstPtr | getInputCloud () const
| Get the input cloud this comparator operates on.

## Protected Attributes

PointCloudNConstPtr | normals_
shared_ptr< std::vector< float > > | plane_coeff_d_
float | angular_threshold_
float | distance_threshold_
bool | depth_dependent_
Eigen::Vector3f | z_axis_
Protected Attributes inherited from pcl::Comparator< PointT >
PointCloudConstPtr | input_

## Detailed Description

template<typename PointT, typename PointNT>
class pcl::PlaneCoefficientComparator< PointT, PointNT >

PlaneCoefficientComparator is a Comparator that operates on plane coefficients, for use in planar segmentation.

In conjunction with OrganizedConnectedComponentSegmentation, this allows planes to be segmented from organized data.

Author
  Alex Trevor

Definition at line 55 of file plane_coefficient_comparator.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointT , typename PointNT >

using pcl::PlaneCoefficientComparator< PointT, PointNT >::ConstPtr = shared_ptr<const PlaneCoefficientComparator<PointT, PointNT> >

Definition at line 66 of file plane_coefficient_comparator.h.

## PointCloud

template<typename PointT , typename PointNT >

using pcl::PlaneCoefficientComparator< PointT, PointNT >::PointCloud = typename Comparator<PointT>::PointCloud

Definition at line 58 of file plane_coefficient_comparator.h.

## PointCloudConstPtr

template<typename PointT , typename PointNT >

using pcl::PlaneCoefficientComparator< PointT, PointNT >::PointCloudConstPtr = typename Comparator<PointT>::PointCloudConstPtr

Definition at line 59 of file plane_coefficient_comparator.h.

## PointCloudN

template<typename PointT , typename PointNT >

using pcl::PlaneCoefficientComparator< PointT, PointNT >::PointCloudN = pcl::PointCloud<PointNT>

Definition at line 61 of file plane_coefficient_comparator.h.

## PointCloudNConstPtr

template<typename PointT , typename PointNT >

using pcl::PlaneCoefficientComparator< PointT, PointNT >::PointCloudNConstPtr = typename PointCloudN::ConstPtr

Definition at line 63 of file plane_coefficient_comparator.h.

## PointCloudNPtr

template<typename PointT , typename PointNT >

using pcl::PlaneCoefficientComparator< PointT, PointNT >::PointCloudNPtr = typename PointCloudN::Ptr

Definition at line 62 of file plane_coefficient_comparator.h.

## Ptr

template<typename PointT , typename PointNT >

using pcl::PlaneCoefficientComparator< PointT, PointNT >::Ptr = shared_ptr<PlaneCoefficientComparator<PointT, PointNT> >

Definition at line 65 of file plane_coefficient_comparator.h.

## Constructor & Destructor Documentation

## PlaneCoefficientComparator() [1/2]

template<typename PointT , typename PointNT >

pcl::PlaneCoefficientComparator< PointT, PointNT >::PlaneCoefficientComparator | ( |  | ) |

inline

Empty constructor for PlaneCoefficientComparator.

Definition at line 71 of file plane_coefficient_comparator.h.

## PlaneCoefficientComparator() [2/2]

template<typename PointT , typename PointNT >

pcl::PlaneCoefficientComparator< PointT, PointNT >::PlaneCoefficientComparator | ( | shared_ptr< std::vector< float > > & | plane_coeff_d | ) |

inline

Constructor for PlaneCoefficientComparator.

Parameters

  [in] | plane_coeff_d | a reference to a vector of d coefficients of plane equations. Must be the same size as the input cloud and input normals. a, b, and c coefficients are in the input normals.

Definition at line 83 of file plane_coefficient_comparator.h.

## ~PlaneCoefficientComparator()

template<typename PointT , typename PointNT >

pcl::PlaneCoefficientComparator< PointT, PointNT >::~PlaneCoefficientComparator | ( |  | ) |

override default

Destructor for PlaneCoefficientComparator.

## Member Function Documentation

## compare()

template<typename PointT , typename PointNT >

bool pcl::PlaneCoefficientComparator< PointT, PointNT >::compare | ( | int | idx1,
|  | int | idx2
| ) |  | const

inline override virtual

Compare points at two indices by their plane equations.

True if the angle between the normals is less than the angular threshold, and the difference between the d component of the normals is less than distance threshold, else false

Parameters

  idx1 | The first index for the comparison
  idx2 | The second index for the comparison

Implements pcl::Comparator< PointT >.

Reimplemented in pcl::PlaneRefinementComparator< PointT, PointNT, PointLT >, and pcl::RGBPlaneCoefficientComparator< PointT, PointNT >.

Definition at line 185 of file plane_coefficient_comparator.h.

References pcl::PlaneCoefficientComparator< PointT, PointNT >::angular_threshold_, pcl::PlaneCoefficientComparator< PointT, PointNT >::depth_dependent_, pcl::PlaneCoefficientComparator< PointT, PointNT >::distance_threshold_, pcl::PlaneCoefficientComparator< PointT, PointNT >::normals_, pcl::PlaneCoefficientComparator< PointT, PointNT >::plane_coeff_d_, and pcl::PlaneCoefficientComparator< PointT, PointNT >::z_axis_.

## getAngularThreshold()

template<typename PointT , typename PointNT >

float pcl::PlaneCoefficientComparator< PointT, PointNT >::getAngularThreshold | ( |  | ) | const

inline

Get the angular threshold in radians for difference in normal direction between neighboring points, to be considered part of the same plane.

Definition at line 155 of file plane_coefficient_comparator.h.

References pcl::PlaneCoefficientComparator< PointT, PointNT >::angular_threshold_.

## getDistanceThreshold()

template<typename PointT , typename PointNT >

float pcl::PlaneCoefficientComparator< PointT, PointNT >::getDistanceThreshold | ( |  | ) | const

inline

Get the distance threshold in meters (d component of plane equation) between neighboring points, to be considered part of the same plane.

Definition at line 174 of file plane_coefficient_comparator.h.

References pcl::PlaneCoefficientComparator< PointT, PointNT >::distance_threshold_.

## getInputNormals()

template<typename PointT , typename PointNT >

PointCloudNConstPtr pcl::PlaneCoefficientComparator< PointT, PointNT >::getInputNormals | ( |  | ) | const

inline

Get the input normals.

Definition at line 114 of file plane_coefficient_comparator.h.

References pcl::PlaneCoefficientComparator< PointT, PointNT >::normals_.

## getPlaneCoeffD()

template<typename PointT , typename PointNT >

const std::vector< float > & pcl::PlaneCoefficientComparator< PointT, PointNT >::getPlaneCoeffD | ( |  | ) | const

inline

Get a pointer to the vector of the d-coefficient of the planes' hessian normal form.

Definition at line 139 of file plane_coefficient_comparator.h.

References pcl::PlaneCoefficientComparator< PointT, PointNT >::plane_coeff_d_.

## setAngularThreshold()

template<typename PointT , typename PointNT >

virtual void pcl::PlaneCoefficientComparator< PointT, PointNT >::setAngularThreshold | ( | float | angular_threshold | ) |

inline virtual

Set the tolerance in radians for difference in normal direction between neighboring points, to be considered part of the same plane.

Parameters

  [in] | angular_threshold | the tolerance in radians

Definition at line 148 of file plane_coefficient_comparator.h.

References pcl::PlaneCoefficientComparator< PointT, PointNT >::angular_threshold_.

## setDistanceThreshold()

template<typename PointT , typename PointNT >

void pcl::PlaneCoefficientComparator< PointT, PointNT >::setDistanceThreshold | ( | float | distance_threshold,
|  | bool | depth_dependent = `false`
| ) |  |

inline

Set the tolerance in meters for difference in perpendicular distance (d component of plane equation) to the plane between neighboring points, to be considered part of the same plane.

Parameters

  [in] | distance_threshold | the tolerance in meters (at 1m)
  [in] | depth_dependent | whether to scale the threshold based on range from the sensor (default: false)

Definition at line 165 of file plane_coefficient_comparator.h.

References pcl::PlaneCoefficientComparator< PointT, PointNT >::depth_dependent_, and pcl::PlaneCoefficientComparator< PointT, PointNT >::distance_threshold_.

## setInputCloud()

template<typename PointT , typename PointNT >

void pcl::PlaneCoefficientComparator< PointT, PointNT >::setInputCloud | ( | const PointCloudConstPtr & | cloud | ) |

inline override virtual

Set the input cloud for the comparator.

Parameters

  [in] | cloud | the point cloud this comparator will operate on

Reimplemented from pcl::Comparator< PointT >.

Definition at line 98 of file plane_coefficient_comparator.h.

References pcl::Comparator< PointT >::input_.

## setInputNormals()

template<typename PointT , typename PointNT >

void pcl::PlaneCoefficientComparator< PointT, PointNT >::setInputNormals | ( | const PointCloudNConstPtr & | normals | ) |

inline

Provide a pointer to the input normals.

Parameters

  [in] | normals | the input normal cloud

Definition at line 107 of file plane_coefficient_comparator.h.

References pcl::PlaneCoefficientComparator< PointT, PointNT >::normals_.

## setPlaneCoeffD() [1/2]

template<typename PointT , typename PointNT >

void pcl::PlaneCoefficientComparator< PointT, PointNT >::setPlaneCoeffD | ( | shared_ptr< std::vector< float > > & | plane_coeff_d | ) |

inline

Provide a pointer to a vector of the d-coefficient of the planes' hessian normal form.

a, b, and c are provided by the normal cloud.

Parameters

  [in] | plane_coeff_d | a pointer to the plane coefficients.

Definition at line 123 of file plane_coefficient_comparator.h.

References pcl::PlaneCoefficientComparator< PointT, PointNT >::plane_coeff_d_.

## setPlaneCoeffD() [2/2]

template<typename PointT , typename PointNT >

void pcl::PlaneCoefficientComparator< PointT, PointNT >::setPlaneCoeffD | ( | std::vector< float > & | plane_coeff_d | ) |

inline

Provide a pointer to a vector of the d-coefficient of the planes' hessian normal form.

a, b, and c are provided by the normal cloud.

Parameters

  [in] | plane_coeff_d | a pointer to the plane coefficients.

Definition at line 132 of file plane_coefficient_comparator.h.

References pcl::PlaneCoefficientComparator< PointT, PointNT >::plane_coeff_d_.

## Member Data Documentation

## angular_threshold_

template<typename PointT , typename PointNT >

float pcl::PlaneCoefficientComparator< PointT, PointNT >::angular_threshold_

protected

Definition at line 202 of file plane_coefficient_comparator.h.

Referenced by pcl::EdgeAwarePlaneComparator< PointT, PointNT >::compare(), pcl::EuclideanPlaneCoefficientComparator< PointT, PointNT >::compare(), pcl::PlaneCoefficientComparator< PointT, PointNT >::compare(), pcl::RGBPlaneCoefficientComparator< PointT, PointNT >::compare(), pcl::PlaneCoefficientComparator< PointT, PointNT >::getAngularThreshold(), and pcl::PlaneCoefficientComparator< PointT, PointNT >::setAngularThreshold().

## depth_dependent_

template<typename PointT , typename PointNT >

bool pcl::PlaneCoefficientComparator< PointT, PointNT >::depth_dependent_

protected

Definition at line 204 of file plane_coefficient_comparator.h.

Referenced by pcl::EdgeAwarePlaneComparator< PointT, PointNT >::compare(), pcl::PlaneCoefficientComparator< PointT, PointNT >::compare(), and pcl::PlaneCoefficientComparator< PointT, PointNT >::setDistanceThreshold().

## distance_threshold_

template<typename PointT , typename PointNT >

float pcl::PlaneCoefficientComparator< PointT, PointNT >::distance_threshold_

protected

Definition at line 203 of file plane_coefficient_comparator.h.

Referenced by pcl::EdgeAwarePlaneComparator< PointT, PointNT >::compare(), pcl::EuclideanPlaneCoefficientComparator< PointT, PointNT >::compare(), pcl::PlaneCoefficientComparator< PointT, PointNT >::compare(), pcl::PlaneRefinementComparator< PointT, PointNT, PointLT >::compare(), pcl::RGBPlaneCoefficientComparator< PointT, PointNT >::compare(), pcl::PlaneCoefficientComparator< PointT, PointNT >::getDistanceThreshold(), and pcl::PlaneCoefficientComparator< PointT, PointNT >::setDistanceThreshold().

## normals_

template<typename PointT , typename PointNT >

PointCloudNConstPtr pcl::PlaneCoefficientComparator< PointT, PointNT >::normals_

protected

Definition at line 200 of file plane_coefficient_comparator.h.

Referenced by pcl::EdgeAwarePlaneComparator< PointT, PointNT >::compare(), pcl::EuclideanPlaneCoefficientComparator< PointT, PointNT >::compare(), pcl::PlaneCoefficientComparator< PointT, PointNT >::compare(), pcl::RGBPlaneCoefficientComparator< PointT, PointNT >::compare(), pcl::PlaneCoefficientComparator< PointT, PointNT >::getInputNormals(), and pcl::PlaneCoefficientComparator< PointT, PointNT >::setInputNormals().

## plane_coeff_d_

template<typename PointT , typename PointNT >

shared_ptr<std::vector<float> > pcl::PlaneCoefficientComparator< PointT, PointNT >::plane_coeff_d_

protected

Definition at line 201 of file plane_coefficient_comparator.h.

Referenced by pcl::EdgeAwarePlaneComparator< PointT, PointNT >::compare(), pcl::PlaneCoefficientComparator< PointT, PointNT >::compare(), pcl::PlaneCoefficientComparator< PointT, PointNT >::getPlaneCoeffD(), pcl::PlaneCoefficientComparator< PointT, PointNT >::setPlaneCoeffD(), and pcl::PlaneCoefficientComparator< PointT, PointNT >::setPlaneCoeffD().

## z_axis_

template<typename PointT , typename PointNT >

Eigen::Vector3f pcl::PlaneCoefficientComparator< PointT, PointNT >::z_axis_

protected

Definition at line 205 of file plane_coefficient_comparator.h.

Referenced by pcl::EdgeAwarePlaneComparator< PointT, PointNT >::compare(), pcl::PlaneCoefficientComparator< PointT, PointNT >::compare(), and pcl::PlaneRefinementComparator< PointT, PointNT, PointLT >::compare().

The documentation for this class was generated from the following file:

- pcl/segmentation/plane_coefficient_comparator.h